"use strict";

exports.__esModule = true;
exports.tempAssign = undefined;
exports.resolveArgumentsVar = resolveArgumentsVar;
exports.downArrowFunctions = downArrowFunctions;

var _kit = require("./kit");

var Kit = _interopRequireWildcard(_kit);

var _core = require("./core");

var _assert = require("assert");

var assert = _interopRequireWildcard(_assert);

var _trace = require("./trace");

var Trace = _interopRequireWildcard(_trace);

var _scope = require("./scope");

var Scope = _interopRequireWildcard(_scope);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/** is to be converted into variable declaration if its `sym` is ever used */
const tempAssign = exports.tempAssign = newSym("tempAssign"); /**
                                                               * A few simple es6 to es5 conversions. They are not ES6 fully standard conforming, 
                                                               * and to be used only as a postprocessing of other transform, using ES6 syntax
                                                               * for simplification. They change synthesized nodes.
                                                               */


function isSynth(value) {}

/**
 * if generated function uses `arguments` variable it will be aliased 
 * to the closest not-generated function's ancestor  
 */
function resolveArgumentsVar() {
  const s = Kit.auto(si);
}

function downArrowFunctions(si) {
  const s = Kit.auto(si);
  function* walk(sw, curThis) {
    for (const i of s.sub()) {
      if (i.enter) {
        if ((0, _core.symInfo)(i.type).func && !i.leave) {
          if (i.type === _core.Tag.ArrowFunctionExpression && isSynth(i.value)) {
            const lab = s.label();
            yield s.enter(i.pos, _core.Tag.FunctionExpression, i.value);
            let j = s.curLev();
            if (j && j.pos === _core.Tag.params) {
              // expecting no default args in syn fun
              yield* s.one();
              j = s.curLev();
            }
            if (j && j.pos === _core.Tag.body) {
              if ((0, _core.symInfo)(j.type).expr) {
                yield s.enter(_core.Tag.body, _core.Tag.BlockStatement);
                yield s.enter(_core.Tag.body, _core.Tag.Array);
                yield s.enter(_core.Tag.push, _core.Tag.ReturnStatement);
                yield* Kit.reposOne(walk(s.one(), curThis), _core.Tag.argument);
              } else yield* walk(s.one(), curThis);
            }
            yield* lab();
            s.close(i);
            continue;
          }
          yield i;
          for (const j of s.sub()) {
            yield j;
            if (j.enter) {
              switch (j.pos) {
                case _core.Tag.params:
                  yield* walk(s.sub(), curThis);
                  break;
                case _core.Tag.body:
                  yield s.take();
                  const sym = Scope.newSym("t");
                  yield s.enter(_core.Tag.push, tempAssign, { sym });
                  yield s.tok(_core.Tag.init, _core.Tag.ThisExpression);
                  yield* s.leave();
                  yield* walk(sym);
                  yield* s.tillClose(i);
                  break;
              }
            }
          }
          continue;
        }
        if (i.type === _core.Tag.ThisExpression) {
          yield s.tok(i.pos, _core.Tag.Identifier, { sym: curThis });
          s.close(i);
          continue;
        }
      }
      yield i;
    }
  }
  return walk();
}