"use strict";

var _core = require("../core");

var _kit = require("../kit");

var Kit = _interopRequireWildcard(_kit);

var _scope = require("../scope");

var Scope = _interopRequireWildcard(_scope);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _assert = require("assert");

var assert = _interopRequireWildcard(_assert);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function* replaceCalls(si) {
  var s = Kit.auto(si);
  function* walk(sw) {
    for (var i of s.sub()) {
      yield i;
      if (i.enter && i.type === _core.Tag.CallExpression) {
        var lab = s.label();
        var j = s.curLev();
        yield s.enter(_core.Tag.callee, _core.Tag.MemberExpression);
        var sym = void 0;
        switch (j.type) {
          case _core.Tag.Identifier:
            sym = j.value.sym;
            yield* Kit.reposOne(s.one(), _core.Tag.object);
            break;
          default:
            yield s.enter(_core.Tag.object, _core.Tag.AssignmentExpression, { node: { operator: "=" } });
            sym = yield* Scope.emitTempVar();
            yield s.tok(_core.Tag.left, _core.Tag.Identifiier, { sym });
            yield* Kit.reposOne(walk(s.one()), _core.Tag.right);
            yield* s.leave();
        }
        yield s.tok(_core.Tag.property, _core.Tag.Identifier, { node: { name: "call" } });
        yield s.peel();
        yield s.tok(_core.Tag.push, _core.Tag.Identifier, { sym });
        yield* lab();
        break;
      }
    }
  }
  yield s.peel();
  yield* walk(s.cur().value.tempVars = []);
  yield* s.leave();
}

function calcClosCapt(si) {
  var sa = Kit.toArray(si);
  var s = Kit.auto(sa);
  function walk(root, sw) {
    root.decls = [];
    root.closCapt = new Set();
    for (var i of sw) {
      if (i.enter) {
        switch (i.type) {
          case _core.Tag.FunctionDeclaration:
            walk(root, s.one());
          case _core.Tag.FunctionExpression:
            walk(i.value);
            break;
          case _core.Tag.Identifier:
            var _si = i.value.sym;
            if (_si != null) {
              if (i.value.decl) root.decls.push(_si);
              if (_si.declScope !== root) {
                (_si.refScopes || (_si.refScopes = new Set())).add(root);
                root.closCapt.add(_si);
              }
            }
        }
      }
    }
  }
  walk();
  return sa;
}

function* functToObj(si) {
  var s = Kit.auto(si);
  var hoisted = [];
  var subst = new Map();
  var rtSym = new Scope.newSym("RT");
  function* walk(sw, root) {
    var decls = [];
    for (var i of sw) {
      if (i.enter) {
        switch (i.type) {
          // TODO: parameters too!!
          case _core.Tag.VariableDeclaration:
            var vlab = s.label();
            if (i.pos === _core.Tag.push) {
              yield s.enter(_core.Tag.push, _core.Tag.ExpressionStatement);
              yield s.enter(_core.Tag.expression, _core.Tag.SequenceExpression);
              yield s.enter(_core.Tag.expressions, _core.Tag.Array);
            }
            for (var j of s.sub()) {
              if (j.enter) {
                for (var _j of s.sub()) {
                  var id = [].concat(_toConsumableArray(s.one()));
                  var _sym = id[0].value.sym;
                  if (s.curLev() != null) {
                    yield* s.template(i.pos, "=$I = $_", _sym);
                    yield* Kit.reposOne(walk(s.one()), _core.Tag.right);
                    yield* s.leave();
                  }
                }
              }
            }
            yield* vlab();
            break;
          case _core.Tag.FunctionDeclaration:
            var decl = true;
          case _core.Tag.FunctionExpression:
            var capt = i.value.closCapt;
            var ctx = i.value.ctx = new Set();
            var sym = Scope.newSym(i.value.node.id && i.value.node.id.name || "fn");
            if (capt && capt.size) {
              var tmp = yield* Scope.emitTempVar();
              yield* s.template(i.pos, "=($1 = new $2(), $_, $1)", tmp, sym);
              for (var _j2 of capt) {
                yield* s.template(_core.Tag.push, "=$I.$I = $_", tmp, _j2);
                yield* Kit.reposOne(walk(s.one(), _core.Tag.right));
                yield* s.leave();
              }
              yield* s.leave();
              hoisted.push([].concat(_toConsumableArray(obj(i.value, sym))));
            }
            continue;
        }
      }
      yield i;
    }
  }
  function* obj(fun, sym) {
    yield* s.template(_core.Tag.push, "function $1(){}; closure($1, function $1() { $_ });", sym);
    yield* walk();
    yield* s.leave();
  }
  var topLab = s.label();
  yield s.peel();
  yield s.peelTo(_core.Tag.body);
  var buf = [].concat(_toConsumableArray(walk(s)));
  for (var i of hoisted) {
    yield* i;
  }yield* buf;
  yield* topLab();
}

// for each Identifier
// if sym from root and clos capt, replcing to reference to local thing
// the local thing if used is replaced to something?